#define TYPE_PLAYER   0
#define TYPE_ANALYSIS 1
#define TYPE_LOADER   2
#define TYPE_ALL      3

typedef struct _generic_plugin {
   char *id;
   char *version;
   char *copyright;
   GModule *handle;
   char *soname;
   int loaded;
   int type;
   void *data;
   struct _generic_plugin *next;
} GenericPlugin;

struct player_plugin {
   void (*init) (struct player_plugin * plug);
   void (*config) (char *left, char *right);
   void (*seek_to_frame) (int second);
   int (*play) (char *song);
   void (*pause) (void);
   void (*stop) (int playing);
   void (*get_info) (struct playlist_item * song);
   int streamable;
   GenericPlugin *parent;
};

struct analysis_plugin {
   int (*init) (Window win, int w, int h);
   void (*do_analysis) (char *buffer, int size);
   void (*close) (void);
   void (*config) (char *left, char *right);
   int size;
   GenericPlugin *parent;
};

extern GenericPlugin *player_plugs;
extern GenericPlugin *analysis_plugs;

struct player_plugin *ReturnPlayerPlugin(char *search);
void InitPlayers(char *path);

struct analysis_plugin *ReturnAnalysisPlugin(char *search);
void InitAnalysis(char *path);

int getnumtracks_cda(void);
